
import './index.css'
//import sensor from './sensor.js'
//import nameGenerator from './name-generator'
//import isDef from './is-def'
import mqtt from 'mqtt'
import {Sensor,
        Temperature,
        Door,
        FanSpeed
        } from './sensor.js'



// Store/retrieve the name in/from a cookie.

// Create a WebSocket connection to the server
//const ws = new WebSocket("ws://" + window.location.host+"/socket");

// We get notified once connected to the server
var client = mqtt.connect('ws://'+ window.location.host+':1234');
client.on('connect', function () {
  client.subscribe('presence');
  //client.subscribe('value/#');
  console.log('connected');
//  client.publish('presence', 'Hello mqtt')
});
client.subscribe('value/#');
const messages = document.querySelector('#messages');

let currentLineAdd;
let currentColumn;
let columnHeader;
let columnAverage;
let where;
let wheres=[];
let datCbr=[];
let degCbr;
let datA111=[];
let degA111;
let columnValue;
let fixCbr;
let fixA111;
let TempChb=new Temperature("temperatureChambre","TEMPERATURE",datCbr,degCbr,"C");
let TempA111=new Temperature("temperatureA111","TEMPERATURE",datA111,degA111,"C");
function change_txt(id,texte) {
    var element = null;
    if (document.getElementById)
      element = document.getElementById(id);

    if (element) element.innerHTML=texte;
  }
client.on('message', function (topic, message) {
  console.log(message.toString());
  let data=JSON.parse(message);

  var type=data.type;
  var value=data.value;
  where=topic.split('/');
  wheres.push(where);


    for(where of wheres){

      columnHeader = document.createElement('td');
      columnHeader.setAttribute("id",type+"_"+where[1]);
      columnHeader.innerHTML=data.type;
      columnValue=document.createElement('td');
      columnValue.setAttribute("id",type+"+"+where[1]);
      columnValue.innerHTML=data.value;
      columnAverage = document.createElement('td');
      if(type==="TEMPERATURE")
      columnAverage.setAttribute("id","Average-"+where[1]);
      else
      columnAverage.setAttribute("id","Value-"+where[1]);
    }
    if (wheres.indexOf(where[1]) === -1){
      wheres.push(where[1]);

      //messages.appendChild(lineHeader);
      currentLineAdd=document.createElement('tr');
      currentLineAdd.setAttribute("id",where[1]);
      currentLineAdd.innerHTML=where[1];
      currentLineAdd.appendChild(columnValue);
      currentLineAdd.appendChild(columnAverage);
      currentLineAdd.appendChild(columnHeader);
    }
    if(where[1]==="temperatureChambre"){
    fixCbr = TempChb.arrond(value);
    TempChb.dat=fixCbr;
    let avg=TempChb.arrond(TempChb.average());
    let Tcbr=fixCbr+" °"+TempChb.unit;
    let Tcbr_AVG=avg+" °"+TempChb.unit;
    console.log(TempChb.dat);
    change_txt("TEMPERATURE+temperatureChambre",Tcbr);
    change_txt("Average-temperatureChambre",Tcbr_AVG);
  }

    if(where[1]==="temperatureSalleA111"){
      fixA111 = TempA111.arrond(value);
      TempA111.dat=fixA111;
      let avg=TempChb.arrond(TempA111.average());
      let T111=fixCbr+" °"+TempA111.unit;
      let T111_AVG=avg+" °"+TempA111.unit;
      change_txt("TEMPERATURE+temperatureSalleA111",T111);
    change_txt("Average-temperatureSalleA111",T111_AVG);
  }
    if(where[1]==="MonAttention"){
      let per=Math.round(value*100);
      let toPer=per+" %";
    change_txt("PERCENT+MonAttention",toPer);
  }
    if(where[1]==="MesYeux")
    change_txt("ON_OFF+MesYeux",value);
   messages.appendChild(currentLineAdd);



});
