
//export const version = () => "1.0.0"
export class Sensor{
  constructor(id,name,data){
    this._id=id;
    this._name=name;
    this._data=data;
  }
  get id() {
    return this._id;
  }
  set id(val) {
    this._id=val;
  }
  get name() {
    return this._name;
  }
  set name(name1) {
    this._name=name1;
  }
  get data(){
    return this._data;
  }
  set data(val){
    this._data.push(val);
  }
//non testé... données non modifiables
/*  set data(dat){
    this._data=dat;
  }*/
}
export class Temperature extends Sensor{
  constructor(id, name, data, degre, unit){
    super(id,name,data);
      this._degre=degre;
      this._unit=unit;
    }
    get degre(){
      return this._degre;
    }
    get unit(){
      return this._unit || 'C';
    }
    set degre(val){
      this._degre=val;
    }
    set unit(u){
      this._unit=u;
    }
    //no need to implement
    //already done by inherited
  /*  get values(){
      return this._data["values"] || [];
    }
    get labels(){
      return this._data["labels"] || [];
    }*/
    nbElemValues(){
      return this._data["values"].length;
    }
    nbElemLabels(){
        return this._data["labels"].length;
    }
    //average doesn't pass test
    averageKLastElem(nbLastElem){
      let i=0;
      let sum=0;
      let offset=this._data["values"].length-nbLastElem;
      for (i=offset;i<this._data["values"].length;i++) {
        sum+=this._data["values"][i];
      }
      let avg=0.0;
      avg=sum/nbLastElem;
      return (avg);
    }
}
  export class Door extends Sensor{
    constructor(id, name, data, state){
      super(id,name);
        this._data=data||{"value":"CLOSE"};
        this._state=this._data["value"];//close:0;open:1
      }
      get state(){
        return this._state;
      }

      set state(st){
        this._state=st;
      }

    }
    export class FanSpeed extends Sensor{
      constructor(id, name, data){
        super(id,name,data);
        //  this._speed=this._data["values"];
        }
      /*  get speed(){
        //  return this._speed || [];
    }

        set speed(sp){
          this._speed=sp;
        }
        get values(){
          return this._data["values"] || [];
        }
        get labels(){
          return this._data["labels"] || [];
        }
        nbElemValues(){
          return this._data["values"].length;
        }
        nbElemLabels(){
            return this._data["labels"].length;
        }*/
        averageKLastElem(nbLastElem){
          let i=0;
          let sum=0;
          let offset=this._data["values"].length-nbLastElem;
          for (i=offset;i<this._data["values"].length;i++) {
            sum+=this._data["values"][i];
          }
          let avg=0.0;
          avg=sum/nbLastElem;
          return (avg);
        }
    }
    export class Humidity extends Sensor{

    }
    export class Light extends Sensor {

    }
    export class MoveDetect extends Sensor{

    }
