
//export const version = () => "1.0.0"
export class Sensor{
  constructor(id,name,dat){
    this._id=id;
    this._name=name;
    this._dat=dat||[];
  }
  get id() {
    return this._id;
  }
  set id(val) {
    this._id=val;
  }
  get name() {
    return this._name;
  }
  set name(name1) {
    this._name=name1;
  }
  get dat(){
    return this._dat;
  }
  set dat(val){
    if(this._dat.length>10)
      this._dat.shift();
    this._dat.push(val);
  }
  arrond(val){
    return Math.round(val*100)/100;
  }
//non testé... données non modifiables
/*  set dat(dat){
    this._dat=dat;
  }*/
}
export class Temperature extends Sensor{
  constructor(id, name, dat, degre, unit){
    super(id,name,dat);
      this._degre=degre;
      this._unit=unit;
    }
    get degre(){
      return this._degre;
    }
    get unit(){
      return this._unit || 'C';
    }
    set degre(val){
      this._degre=val;
    }
    set unit(u){
      this._unit=u;
    }
    //no need to implement
    //already done by inherited
  /*  get values(){
      return this._dat["values"] || [];
    }
    get labels(){
      return this._dat["labels"] || [];
    }*/
    nbElemValues(){
      return this._dat["values"].length;
    }
    nbElemLabels(){
        return this._dat["labels"].length;
    }
    //average doesn't pass test
    average(){
      let i=0;
      let sum=0;
      //let offset=0;

      for (i=0;i<this._dat.length;i++) {
        sum+=this._dat[i];
      }
      let avg=0.0;
      avg=sum/this._dat.length;
      return (avg);
    }
}
  export class Door extends Sensor{
    constructor(id, name, dat, state){
      super(id,name);
        this._dat=dat||{"value":"OFF"};
        this._state=this._dat["value"];//close:0;open:1
      }
      get state(){
        return this._state;
      }

      set state(st){
        this._state=st;
      }

    }
    export class FanSpeed extends Sensor{
      constructor(id, name, dat){
        super(id,name,dat);
        //  this._speed=this._dat["values"];
        }
      /*  get speed(){
        //  return this._speed || [];
    }

        set speed(sp){
          this._speed=sp;
        }
        get values(){
          return this._dat["values"] || [];
        }
        get labels(){
          return this._dat["labels"] || [];
        }
        nbElemValues(){
          return this._dat["values"].length;
        }
        nbElemLabels(){
            return this._dat["labels"].length;
        }*/
        averageKLastElem(nbLastElem){
          let i=0;
          let sum=0;
          let offset=this._dat["values"].length-nbLastElem;
          for (i=offset;i<this._dat["values"].length;i++) {
            sum+=this._dat["values"][i];
          }
          let avg=0.0;
          avg=sum/nbLastElem;
          return (avg);
        }
    }
    export class Humidity extends Sensor{

    }
    export class Light extends Sensor {

    }
    export class MoveDetect extends Sensor{

    }
